<?php
/*
 * @component XLSJuice 
 * @copyright Copyright (C) February 2019. 
 * @license GPL 3.0 
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 * See <http://www.gnu.org/licenses/>. 
 * More info www.moonsoft.es 
 * gestion@moonsoft.es
 */

// No direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.application.component.view' );


require 'main.view.php';
class wrapperMainView extends XlsjuiceMainView {
	private static $COMPNAME = 'com_xlsjuice';
	function display($tpl = null) {
		parent::display ( $tpl );
	}
	
	/**
	 * Get the actions
	 */
	public static function getActions() {
		jimport ( 'joomla.access.access' );
		$user = JFactory::getUser ();
		$result = new JObject ();
		$assetName = wrapperMainView::$COMPNAME;
		$actions = JAccess::getActions ( wrapperMainView::$COMPNAME, 'component' );
		foreach ( $actions as $action ) {
			$result->set ( $action->name, $user->authorise ( $action->name, $assetName ) );
		}
		return $result;
	}
	function __getCSS() {
		$version = new JVersion ();
		$ret = array ();
		return $ret;
	}
	function __getJS() {
		$version = new JVersion ();
		$ret = array ();
		return $ret;
	}
	function __getVersion() {
		$version = new JVersion ();
		$arr_version = explode ( '.', $version->getShortVersion () );
		return $arr_version [0];
	}
}
?>