<?php
/*
 * @component XLSJuice
 * @copyright Copyright (C) February 2019.
 * @license GPL 3.0
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * See <http://www.gnu.org/licenses/>.
 * More info www.moonsoft.es
 * gestion@moonsoft.es
 */

// No direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.filesystem.file' );

// Require the base controller
require_once (JPATH_COMPONENT_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'controller.php');

// Require specific controller if requested
// if($controller = MSHelper::__getRequest()->getWord('controller')) {
if ($controller = JFactory::getApplication()->input->get('controller')) {
	$path = JPATH_COMPONENT_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'controllers' . DIRECTORY_SEPARATOR . $controller . '.php';
	// if (file_exists($path)) {
	if (JFile::exists ( $path )) {
		require_once $path;
	} else {
		$controller = '';
	}
}

// Create the controller
$classname = 'XlsjuiceController' . $controller;
$controller = new $classname ();

// Perform the Request task
$controller->execute (JFactory::getApplication()->input->get('task','show'));

// Redirect if set by the controller
$controller->redirect ();

?>
