<?php
/*
 * @component XLSJuice
 * @copyright Copyright (C) February 2019.
 * @license GPL 3.0
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * See <http://www.gnu.org/licenses/>.
 * More info www.moonsoft.es
 * gestion@moonsoft.es
 */
// no direct access
defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );
$devenvironment=false;
$componentparams = JComponentHelper::getParams('com_xlsjuice');
$user = $componentparams->get('user');
$password = md5($componentparams->get('password'));
$secure = false;
$url='https://xlsjuice.com/external/getexternaljoomlacode';
if ($devenvironment) $url='https://prexlsjuice.com/external/getexternaljoomlacode';
$data=http_build_query(['xls_user'=>$user,'xls_passw'=>$password,'idDoc'=>$params->get('id')]);
$isError=false;
$_retorno ='';
/*
switch($componentparams->get('method')):
	case 'curl':
		$useragent='Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0';
		$header = array();
		$header[] = 'Host: '.($devenvironment?'prexlsjuice.com':'xlsjuice.com');
		$header[] = 'Connection: keep-alive';
		$header[] = 'Pragma: no-cache';
		$header[] = 'Cache-Control: no-cache';
		*/
		//$header[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8';
		/*$header[] = 'User-Agent: '.$useragent;
		$header[] = 'DNT: 1';
		$header[] = 'Origin: '.JUri::current();
		$header[] = 'Referer: '.JUri::current();
		$header[] = 'Accept-Encoding: gzip, deflate';
		$header[] = 'Accept-Language: en-US,en;q=0.8';
		$header[] = 'Expect:';
		$options = array(
			CURLOPT_URL			   => $url,
			CURLOPT_RETURNTRANSFER => true,     // return web page
			CURLOPT_HEADER         => true,    // don't return headers
			CURLOPT_FOLLOWLOCATION => true,     // follow redirects
			CURLOPT_ENCODING       => "",       // handle all encodings
			CURLOPT_CONNECTTIMEOUT => 20,      // timeout on connect
			CURLOPT_TIMEOUT        => 20,      // timeout on response
			CURLOPT_MAXREDIRS      => 100,       // stop after 10 redirects
			CURLOPT_POST		   => true,		// Send Post Data
			CURLOPT_POSTFIELDS     => $data,	// Post Data Fields
			CURLOPT_VERBOSE		   => false,
			CURLOPT_STDERR		   => fopen('php://stderr', 'w'),
			CURLOPT_BINARYTRANSFER => true,
			CURLOPT_COOKIEJAR 	=>fopen('php://stderr', 'w'),
			CURLOPT_REFERER			=>JUri::current(),
			CURLOPT_AUTOREFERER	=>true,
			CURLOPT_USERAGENT		=>$useragent,
		);
		if($secure):
			$options[CURLOPT_SSL_VERIFYPEER]=true;
			$options[CURLOPT_CAINFO]=JPATH_ROOT.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_xlsjuice'.DIRECTORY_SEPARATOR.'cacert.pem';
			$options[CURLOPT_SSL_VERIFYHOST]=2;
		else:
			$options[CURLOPT_SSL_VERIFYPEER]=false;
			$options[CURLOPT_SSL_VERIFYHOST]=0;
		endif;
		$ch = curl_init();
		$fp = tempnam(sys_get_temp_dir(), 'XLSJuice_init');
		$fp_tmp = fopen($fp, 'w'); // Comprobar que tiene permisos de escritura
		curl_setopt_array($ch,$options);
		curl_setopt($ch, CURLOPT_FILE, $fp_tmp);
		curl_exec($ch);
		$err = curl_errno($ch);
		$errmsg  = curl_error( $ch );
		//$info  = curl_getinfo( $ch );
		if (!$err):
			$ret=file_get_contents($fp);
			$header_len = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
			$header = substr($ret, 0, $header_len);
			$encryptedMessage = substr($ret, $header_len);
		else:
			$isError=true;
		endif;
		curl_close($ch);
		unlink($fp);
	break;
	case 'fgc':
		$opts = array('http' =>
		    array(
		        'method'  => 'POST',
		        'header'  => 'Content-type: application/x-www-form-urlencoded',
		        'content' => $data
		    ),"ssl"=>array(
						"cafile"=>JPATH_ROOT.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_xlsjuice'.DIRECTORY_SEPARATOR.'cacert.pem',
	          "verify_peer"=>$secure,
	          "verify_peer_name"=>$secure
	        ),
		);
		$context  = stream_context_create($opts);
		$encryptedMessage = file_get_contents($url, false, $context);
	break;
endswitch;*/
/*
if (!$isError): // Comprobar error en curl
	$secretHash=$user.$password;
	$encryptionMethod="AES-256-CBC";
	$ivret = substr($encryptedMessage, 0, 16);
  $decryptedMessage = openssl_decrypt(substr($encryptedMessage, 16), $encryptionMethod, $secretHash, 0, $ivret);
  $temp_file = tempnam(sys_get_temp_dir(), 'XLSJuice');
	file_put_contents($temp_file,$decryptedMessage); // Comprobar que tiene permisos de escritura
	include $temp_file;
	if (function_exists('_execfn')):
		$_retorno=_execfn(); // Comprobar que existe la función
		$_retorno=json_encode($_retorno);
		$iv=base64_encode(openssl_random_pseudo_bytes(10));
		$_retorno = $iv.openssl_encrypt($_retorno, $encryptionMethod, $secretHash, 0, $iv);
	endif;
	unlink($temp_file);
else:
	?><script>console.error('XLSJuice not connected properly. Please contact to XLSJuice Team');</script><?php
endif;*/
$secretHash=$user.$password;
$encryptionMethod="AES-256-CBC";
$user = JFactory::getUser();
$secret = md5($user->id.JFactory::getApplication()->get('secret',''));
if (!$user->guest)
	$_retorno=['id'=>$secret,'email'=>$user->email,'name'=>$user->name,'username'=>$user->username,'groups'=>$user->groups];
else
	$_retorno=[];
$_retorno=json_encode($_retorno);
$iv=base64_encode(openssl_random_pseudo_bytes(10));
$_retorno = $iv.openssl_encrypt($_retorno, $encryptionMethod, $secretHash, 0, $iv);

require (JModuleHelper::getLayoutPath ( 'mod_xlsjuice', 'default' ));
?>
